<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">

    <!-- bootstrap & jquery -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <script src="plugins/sweetalert2/sweetalert2.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Master Layout</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item dropdown mr-3">
                    <a class="nav-link" data-toggle="dropdown" href="#"><i class="fa-solid fa-user-large"></i></a>
                    <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
                        <span class="dropdown-item dropdown-header" id="user-info"></span>
                        <div class="dropdown-divider"></div>
                        <div class="text-center mt-2">
                            <button class="btn btn-danger" id="btn-log-out"><i
                                    class="fa-solid fa-right-from-bracket"></i> Log out</button>
                        </div>
                    </div>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="addressMap.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">ADMIN Real Estates</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="info text-white ml-2" id="username-info"></div>
                </div>
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class with font-awesome or any other icon font library -->
                        <li class="nav-item">
                            <a href="../CustomerFrontEnd/index.html" class="nav-link">
                                <i class="fa-solid fa-house-chimney-user"></i>
                                <p>
                                    HomePage
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./addressMap.html" class="nav-link ">
                                <i class="fa-solid fa-map-location-dot"></i>
                                <p>
                                    Địa chỉ tọa độ
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./masterLayout.html" class="nav-link active">
                                <i class="fa-solid fa-layer-group"></i>
                                <p>
                                    Mặt bằng tầng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./constructionContractor.html" class="nav-link ">
                                <i class="fa-solid fa-person-digging"></i>
                                <p>
                                    Nhà thầu xây dựng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./designUnit.html" class="nav-link ">
                                <i class="fa-solid fa-compass-drafting"></i>
                                <p>
                                    Đơn vị thiết kế
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./investor.html" class="nav-link ">
                                <i class="fa-solid fa-user-tie"></i>
                                <p>
                                    Nhà đầu tư
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./regionLink.html" class="nav-link">
                                <i class="fa-solid fa-map"></i>
                                <p>
                                    Kết nối vùng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./utilities.html" class="nav-link">
                                <i class="fa-solid fa-person-swimming"></i>
                                <p>
                                    Tiện ích
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./customers.html" class="nav-link ">
                                <i class="fa-solid fa-users-line"></i>
                                <p>
                                    Khách hàng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./employees.html" class="nav-link ">
                                <i class="fa-solid fa-user"></i>
                                <p>
                                    Người dùng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./project.html" class="nav-link">
                                <i class="fa-solid fa-hotel"></i>
                                <p>
                                    Dự án xây dựng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./realestate.html" class="nav-link">
                                <i class="fa-solid fa-city"></i>
                                <p>
                                    Thông tin BĐS
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./requestCounseling.html" class="nav-link">
                                <i class="fa-solid fa-envelope"></i>
                                <p>
                                    Yêu cầu tư vấn
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="#" class="nav-link">
                                <i class="fa-solid fa-bars"></i>
                                <p>
                                    Địa chính
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="./province.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Tỉnh thành</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./district.html" class="nav-link ">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Quận huyện</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./ward.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Phường xã</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./street.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Đường</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a href="./subscription.html" class="nav-link">
                                <i class="fa-solid fa-bell"></i>
                                <p>
                                    Subscription
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Master Layout</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <h4 class="text-center form-group">Master Layout List</h4>
                    <div class="form-group">
                        <button class="btn btn-success" id="btn-create-new-masterLayout"><i
                                class="fa-solid fa-plus"></i>
                            Create New Master Layout</button>
                    </div>
                    <table class="table table-bordered table-striped table-hover" id="masterLayout-table">
                        <thead>
                            <tr>
                                <th>ID</th>
                                <th>Name</th>
                                <th>Description</th>
                                <th>Project</th>
                                <th>Acreage</th>
                                <th>Apartment List</th>
                                <th>Photo</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>

                </div><!-- /.container-fluid -->
            </section>
            <!-- /.content -->

            <!-- Create new masterLayout modal -->
            <div id="create-masterLayout-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-success">
                            <h5 class="modal-title">Create New Master Layout</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Name</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-name" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Description</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-description" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Project<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <select id="create-select-project" class="form-control">
                                            <option value="unSelected">--Project--</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Acreage</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-acreage" type="number" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Apartment List</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-apartment-list" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Photo</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-photo" type="text" class="form-control">
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-primary" id="btn-create-confirm">Confirm</button>
                            <button class="btn btn-secondary" id="btn-create-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- masterLayout Detail modal -->
            <div id="masterLayout-detail-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-success">
                            <h5 class="modal-title">Master Layout Details</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Name</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-name" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Description</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-description" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Project<i class="text-danger">*</i></label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <select id="update-select-project" class="form-control" disabled>
                                        </select>
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Acreage</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-acreage" type="number" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Apartment List</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-apartment-list" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Photo</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-photo" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Date Create</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-date-create" type="text" class="form-control" disabled>
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Date Update</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-date-update" type="text" class="form-control" disabled>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-primary" id="btn-update-confirm">Update Confirm</button>
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Delete masterLayout modal -->
            <div id="delete-masterLayout-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-danger">
                            <h5 class="modal-title">Delete Master Layout Confirmation</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            Are you sure to delete this Master Layout?
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-delete-confirm">Confirm</button>
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

        </div>
        <!-- /.content-wrapper -->
        <footer class="main-footer">

            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
    </div>

    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>

    <script>
        $(document).ready(function () {

            const token = getCookie("token");

            // Biến mảng toàn cục chứa danh sách tên các thuộc tính
            const gDATA_COLS = ["id", "name", "description", "project.name", "acreage", "apartmentList", "photo", "action"];

            // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
            const gID_COL = 0;
            const gNAME_COL = 1;
            const gDESCRIPTION_COL = 2;
            const gPROJECT_COL = 3;
            const gACREAGE_COL = 4;
            const gAPARTMENT_LIST_COL = 5;
            const gPHOTO_COL = 6;
            const gACTION_COL = 7;

            var gTable = $("#masterLayout-table").DataTable({
                columns: [
                    { data: gDATA_COLS[gID_COL] },
                    { data: gDATA_COLS[gNAME_COL] },
                    { data: gDATA_COLS[gDESCRIPTION_COL] },
                    { data: gDATA_COLS[gPROJECT_COL] },
                    { data: gDATA_COLS[gACREAGE_COL] },
                    { data: gDATA_COLS[gAPARTMENT_LIST_COL] },
                    { data: gDATA_COLS[gPHOTO_COL] },
                    { data: gDATA_COLS[gACTION_COL] },
                ],
                "columnDefs": [
                    {
                        "targets": gACTION_COL,
                        "defaultContent": `<button class='btn btn-primary btn-detail-masterLayout'><i class="fa-regular fa-pen-to-square"></i></button>
                <button class='btn btn-danger btn-delete-masterLayout'><i class="fa-regular fa-trash-can"></i></button>`
                    }],
            });

            var gId;

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();

            //Set sự kiện cho nút logout
            $("#btn-log-out").on("click", function () {
                redirectToLogin();
            });

            // gán xự kiện nút tạo mới masterLayout
            $("#btn-create-new-masterLayout").on("click", function () {
                $("#create-masterLayout-modal").modal("show");
            });

            // gán xự kiện  nút chi tiết masterLayout
            $("#masterLayout-table").on("click", ".btn-detail-masterLayout", function () {
                onBtnDetailMasterLayoutClick(this);
            });

            // gán xự kiện  nút xóa masterLayout
            $("#masterLayout-table").on("click", ".btn-delete-masterLayout", function () {
                onBtnDeleteMasterLayoutClick(this);
            });

            // gán xự kiện nút xác nhận tạo mới masterLayout
            $("#btn-create-confirm").on("click", function () {
                onBtnCreateMasterLayoutConfirmClick();
            });

            // gán xự kiện nút xác nhận câp nhật masterLayout
            $("#btn-update-confirm").on("click", function () {
                onBtnUpdateMasterLayoutConfirmClick();
            });

            // gán xự kiện  nút xác nhận xóa masterLayout
            $("#btn-delete-confirm").on("click", function () {
                onBtnDeleteMasterLayoutConfirmClick();
            });

            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                "use strict";
                callApiGetUserIdByToken();
                callApiGetAllMasterLayout();

                callApiGetAllProject();
            }

            // Hàm xử lý khi nút xác nhận tạo mới masterLayout được nhấn
            function onBtnCreateMasterLayoutConfirmClick() {
                "use strict";
                var vCreateData = {
                    name: "",
                    description: "",
                    acreage: "",
                    apartmentList: "",
                    photo: "",
                }
                // B1: Thu thập dữ liệu
                var vSelectProjectValue = $("#create-select-project").val();
                getCreateData(vCreateData);
                // B2: Kiểm tra dữ liệu
                var isValidate = validateCreateData(vCreateData, vSelectProjectValue);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiCreateNewMasterLayout(vCreateData, vSelectProjectValue);
                    // gọi lại tất cả masterLayout
                    callApiGetAllMasterLayout();
                    // Ẩn modal
                    $("#create-masterLayout-modal").modal("hide");
                    // clear dữ liệu trên modal
                    clearDataInCreateModal();
                }
            }

            // Hàm xử lý khi nút chi tiết masterLayout được nhấn
            function onBtnDetailMasterLayoutClick(paramBtnDetail) {
                "use strict";
                // B1: Thu thập dữ liệu
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramBtnDetail).parents('tr');
                // Lấy các dữ liệu của hàng có cùng hàng với nút được nhấn
                var vDataRow = gTable.row(vRowSelected).data();
                console.log(vDataRow);
                gId = vDataRow.id;
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu vào modal
                callApiGetMasterLayoutDataById();
                // Hiện modal
                $("#masterLayout-detail-modal").modal("show");
            }

            // Hàm xử lý khi nút chi tiết masterLayout được nhấn
            function onBtnDeleteMasterLayoutClick(paramBtnDetail) {
                "use strict";
                // B1: Thu thập dữ liệu
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramBtnDetail).parents('tr');
                // Lấy các dữ liệu của hàng có cùng hàng với nút được nhấn
                var vDataRow = gTable.row(vRowSelected).data();
                gId = vDataRow.id;
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu vào modal
                // Hiện modal
                $("#delete-masterLayout-modal").modal("show");
            }

            // Hàm xử lý khi nút xác nhận cập nhật masterLayout được nhấn
            function onBtnUpdateMasterLayoutConfirmClick() {
                "use strict";
                var vUpdateData = {
                    name: "",
                    description: "",
                    projects: "",
                    address: "",
                    phone: "",
                    phone2: "",
                    fax: "",
                    email: "",
                    website: "",
                    note: "",
                }
                // B1: Thu thập dữ liệu
                getUpdateData(vUpdateData);
                // B2: Kiểm tra dữ liệu
                var isValidate = validateUpdateData(vUpdateData);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiUpdateMasterLayout(vUpdateData);
                    // gọi lại tất cả masterLayouts
                    callApiGetAllMasterLayout();
                    // Ẩn modal
                    $("#masterLayout-detail-modal").modal("hide");
                }
            }

            // Hàm xử lý khi nút xác nhận xóa masterLayout được nhấn
            function onBtnDeleteMasterLayoutConfirmClick() {
                "use strict";
                // B1: Thu thập dữ liệu (bỏ qua)
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu
                callApiDeleteMasterLayout();
                // gọi lại tất cả masterLayouts
                callApiGetAllMasterLayout();
                // Ẩn modal
                $("#delete-masterLayout-modal").modal("hide");
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            // Hàm load dữ liệu vào bảng
            function loadDataToTable(paramData) {
                "use strict";
                //Xóa toàn bộ dữ liệu đang có của bảng
                gTable.clear();
                //Cập nhật data cho bảng
                gTable.rows.add(paramData);
                //Cập nhật lại giao diện hiển thị bảng
                gTable.draw();
            }

            function callApiGetUserIdByToken() {
                $.ajax({
                    url: "http://localhost:8080/findUserId/Token",
                    type: 'GET',
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    headers: {
                        "Authorization": "Token " + token,
                    },
                    success: function (responseObject) {
                        //console.log(responseObject);
                        callApiGetEmployeeByID(responseObject);
                    },
                    error: function (pAjaxContext) {
                        //redirectToLogin();
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu employee bằng id
            function callApiGetEmployeeByID(paramEmployeeId) {
                $.ajax({
                    url: "http://localhost:8080/employees/" + paramEmployeeId,
                    method: "GET",
                    async: false,
                    success: function (paramResponseObj) {
                        console.log(paramResponseObj);
                        handlerUserDataResponse(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function handlerUserDataResponse(paramUserData) {
                $("#username-info").html(paramUserData.username);
                $("#user-info").html(paramUserData.username);
            }

            // Hàm gọi api lấy tất cả masterLayout
            function callApiGetAllMasterLayout() {
                $.ajax({
                    url: "http://localhost:8080/masterLayouts",
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToTable(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api lấy tất cả project
            function callApiGetAllProject() {
                $.ajax({
                    url: "http://localhost:8080/projects",
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToProjectSelectOnCreateModal(paramResponseObj);
                        loadDataToProjectSelectOnUpdateModal(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu masterLayout bằng id
            function callApiGetMasterLayoutDataById() {
                $.ajax({
                    url: "http://localhost:8080/masterLayouts/" + gId,
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataOnDetailModal(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api tạo masterLayout
            function callApiCreateNewMasterLayout(paramCreateData, paramProjectValue) {
                $.ajax({
                    url: "http://localhost:8080/masterLayouts/project/" + paramProjectValue,
                    method: "POST",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramCreateData),
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm gọi api cập nhật masterLayout
            function callApiUpdateMasterLayout(paramUpdateData) {
                $.ajax({
                    url: "http://localhost:8080/masterLayouts/" + gId,
                    method: "PUT",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramUpdateData),
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm gọi api xóa masterLayout
            function callApiDeleteMasterLayout() {
                $.ajax({
                    url: "http://localhost:8080/masterLayouts/" + gId,
                    method: "DELETE",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm thu thập dữ liệu để tạo masterLayout
            function getCreateData(paramCreateData) {
                "use strict";
                paramCreateData.name = $("#create-input-name").val().trim();
                paramCreateData.description = $("#create-input-description").val().trim();
                paramCreateData.acreage = $("#create-input-acreage").val().trim();
                paramCreateData.apartmentList = $("#create-input-apartment-list").val().trim();
                paramCreateData.photo = $("#create-input-photo").val().trim();
            }

            // Hàm thu thập dữ liệu để cap nhat masterLayout
            function getUpdateData(paramUpdateData) {
                "use strict";
                paramUpdateData.name = $("#update-input-name").val().trim();
                paramUpdateData.description = $("#update-input-description").val().trim();
                paramUpdateData.acreage = $("#update-input-acreage").val().trim();
                paramUpdateData.apartmentList = $("#update-input-apartment-list").val().trim();
                paramUpdateData.photo = $("#update-input-photo").val().trim();
            }

            // Hàm kiểm tra dữ liệu để tạo masterLayout
            function validateCreateData(paramCreateData, paramProjectValue) {
                "use strict";
                if (paramCreateData.name == "") {
                    alertError("Name không được để trống");
                    return false;
                }
                if (paramProjectValue == "unSelected") {
                    alertError("Project phải được chọn.");
                    return false;
                }
                return true;
            }

            // Hàm kiểm tra dữ liệu để cap nhat masterLayout
            function validateUpdateData(paramUpdateData, paramProjectValue) {
                "use strict";
                if (paramUpdateData.name == "") {
                    alertError("Name không được để trống");
                    return false;
                }
                if (paramProjectValue == "unSelected") {
                    alertError("Project phải được chọn.");
                    return false;
                }
                return true;
            }

            // Xóa trắng dữ liệu trong form create modal
            function clearDataInCreateModal() {
                $("#create-input-name").val("");
                $("#create-input-description").val("");
                $("#create-select-project").val(0);
                $("#create-input-acreage").val("");
                $("#create-input-apartment-list").val("");
                $("#create-input-photo").val("");
            }

            // load dữ liệu vào form trên detail modal
            function loadDataOnDetailModal(paramRowData) {
                $("#update-input-name").val(paramRowData.name);
                $("#update-input-description").val(paramRowData.description);
                $("#update-select-project").val(paramRowData.project.id);
                $("#update-input-acreage").val(paramRowData.acreage);
                $("#update-input-apartment-list").val(paramRowData.apartmentList);
                $("#update-input-photo").val(paramRowData.photo);
                $("#update-input-date-create").val(paramRowData.dateCreate);
                $("#update-input-date-update").val(paramRowData.dateUpdate);
            }

            // Load dữ liệu vào ô select trên modal create masterLayout
            function loadDataToProjectSelectOnCreateModal(paramResponse) {
                "use strict";
                var vSelectProject = $("#create-select-project");
                for (let i = 0; i < paramResponse.length; i++) {
                    var bOption = $("<option/>");
                    bOption.prop("value", paramResponse[i].id);
                    bOption.prop("text", paramResponse[i].name);
                    vSelectProject.append(bOption);
                };
            }

            // Load dữ liệu vào ô select trên modal update masterLayout
            function loadDataToProjectSelectOnUpdateModal(paramResponse) {
                "use strict";
                var vSelectProject = $("#update-select-project");
                for (let i = 0; i < paramResponse.length; i++) {
                    var bOption = $("<option/>");
                    bOption.prop("value", paramResponse[i].id);
                    bOption.prop("text", paramResponse[i].name);
                    vSelectProject.append(bOption);
                };
            }

            function redirectToLogin() {
                // Trước khi logout cần xóa token đã lưu trong cookie
                setCookie("token", "", 1);
                window.location.href = "index.html";
            }

            //Hàm get Cookie
            function getCookie(cname) {
                var name = cname + "=";
                var decodedCookie = decodeURIComponent(document.cookie);
                var ca = decodedCookie.split(';');
                for (var i = 0; i < ca.length; i++) {
                    var c = ca[i];
                    while (c.charAt(0) == ' ') {
                        c = c.substring(1);
                    }
                    if (c.indexOf(name) == 0) {
                        return c.substring(name.length, c.length);
                    }
                }
                return "";
            }

            //Hàm setCookie đã giới thiệu ở bài trước
            function setCookie(cname, cvalue, exdays) {
                var d = new Date();
                d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
                var expires = "expires=" + d.toUTCString();
                document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
            }

            // Hàm alert success
            function alertSuccess(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'success',
                        title: paramTitle,
                    })
                });
            }

            // Hàm alert lỗi
            function alertError(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'error',
                        title: paramTitle,
                    })
                });
            }


        });

    </script>
</body>